%global __strip %{_mingw32_strip}
%global __objdump %{_mingw32_objdump}
%global _use_internal_dependency_generator 0
%global __find_requires %{_mingw32_findrequires}
%global __find_provides %{_mingw32_findprovides}

%global apivers 2.8.2
%global srcvers 2.8.2

Name:           mingw32-OpenSceneGraph
Version:        %{apivers}
Release:        2%{?dist}
Summary:        Fedora mingw high performance real-time graphics toolkit

Group:          Development/Libraries
# The OSGPL is just the wxWidgets license.
License:        wxWidgets
URL:            http://www.openscenegraph.org/
Source0:        http://www.openscenegraph.org/downloads/stable_releases/OpenSceneGraph-%{version}/source/OpenSceneGraph-%{version}.zip

#native versions patches:
Patch0:         OpenSceneGraph-%{version}.diff

# mingw specific patches:
Patch100:       mingw32-OSG-disable-problematic-plugins.diff
Patch101:       mingw32-OSG-jpeg-boolean-fix.diff

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:      noarch

BuildRequires:  mingw32-filesystem >= 35
BuildRequires:  mingw32-gcc
BuildRequires:  mingw32-gcc-c++
BuildRequires:  mingw32-binutils

BuildRequires:  mingw32-libjpeg
BuildRequires:  mingw32-libtiff
BuildRequires:  mingw32-libpng
BuildRequires:  mingw32-pthreads
BuildRequires:  mingw32-gtk2
BuildRequires:  cmake

Requires:       pkgconfig

# OSG packaging madness ;)
%define OSGSRCDIR       OpenSceneGraph-%{version}

%description
The OpenSceneGraph is an OpenSource, cross platform graphics toolkit for the 
development of high performance graphics applications such as flight 
simulators, games, virtual reality and scientific visualization. 
Based around the concept of a SceneGraph, it provides an object oriented 
framework on top of OpenGL freeing the developer from implementing and 
optimizing low level graphics calls, and provides many additional utilities 
for rapid development of graphics applications.

%{_mingw32_description}

# Automatically create a debuginfo package
%{_mingw32_debug_package}

%prep
%setup -q -c
cd %{OSGSRCDIR}
%patch0 -p1
%patch100 -p1
%patch101 -p1
cd ..

%build
mkdir -p BUILD
pushd BUILD

%_mingw32_cmake -DBUILD_OSG_EXAMPLES=OFF -DBUILD_OSG_WRAPPERS=OFF -DBUILD_DOCUMENTATION=OFF ../%{OSGSRCDIR}
make %{?_smp_mflags}

popd

%install
rm -rf $RPM_BUILD_ROOT
pushd BUILD
make install DESTDIR=$RPM_BUILD_ROOT

popd

# fix non utf-8 encoding
iconv --from=ISO-8859-1 --to=UTF-8 %{OSGSRCDIR}/AUTHORS.txt > %{OSGSRCDIR}/AUTHORS.txt.new && \
touch -r %{OSGSRCDIR}/AUTHORS.txt %{OSGSRCDIR}/AUTHORS.txt.new && \
mv %{OSGSRCDIR}/AUTHORS.txt.new %{OSGSRCDIR}/AUTHORS.txt

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc %{OSGSRCDIR}/{AUTHORS,LICENSE,NEWS,README}.txt

%{_mingw32_libdir}/pkgconfig/openscenegraph.pc
%dir %{_mingw32_bindir}/osgPlugins-%{apivers}/
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_zip.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_x.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_vtf.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_txf.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_trans.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_tiff.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_tgz.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_tga.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_stl.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_shp.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_scale.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_rot.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_rgb.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_pnm.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_png.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_pic.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_osgwidget.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_osgvolume.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_osgviewer.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_osgtgz.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_osgtext.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_osgterrain.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_osgsim.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_osgshadow.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_osgparticle.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_osgfx.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_osganimation.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_osga.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_osg.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_openflight.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_obj.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_normals.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_mdl.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_md2.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_lws.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_lwo.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_logo.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_jpeg.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_ive.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_hdr.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_gz.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_glsl.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_geo.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_dxf.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_dw.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_dot.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_dds.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_cfg.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_bvh.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_bsp.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_bmp.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_ac.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_3ds.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_3dc.dll
%{_mingw32_bindir}/osgPlugins-%{apivers}/mingw_osgdb_freetype.dll

%{_mingw32_bindir}/libosgWidget.dll
%{_mingw32_bindir}/libosgVolume.dll
%{_mingw32_bindir}/libosgViewer.dll
%{_mingw32_bindir}/libosgUtil.dll
%{_mingw32_bindir}/libosgText.dll
%{_mingw32_bindir}/libosgTerrain.dll
%{_mingw32_bindir}/libosgSim.dll
%{_mingw32_bindir}/libosgShadow.dll
%{_mingw32_bindir}/libosgParticle.dll
%{_mingw32_bindir}/libosgManipulator.dll
#%%{_mingw32_bindir}/libosgIntrospection.dll
%{_mingw32_bindir}/libosgGA.dll
%{_mingw32_bindir}/libosgFX.dll
%{_mingw32_bindir}/libosgDB.dll
%{_mingw32_bindir}/libosgAnimation.dll
%{_mingw32_bindir}/libosg.dll
%{_mingw32_bindir}/osgviewer.exe
%{_mingw32_bindir}/osgversion.exe
%{_mingw32_bindir}/osgfilecache.exe
%{_mingw32_bindir}/osgconv.exe
%{_mingw32_bindir}/osgarchive.exe

%{_mingw32_libdir}/libosgWidget.dll.a
%{_mingw32_libdir}/libosgVolume.dll.a
%{_mingw32_libdir}/libosgViewer.dll.a
%{_mingw32_libdir}/libosgUtil.dll.a
%{_mingw32_libdir}/libosgText.dll.a
%{_mingw32_libdir}/libosgTerrain.dll.a
%{_mingw32_libdir}/libosgSim.dll.a
%{_mingw32_libdir}/libosgShadow.dll.a
%{_mingw32_libdir}/libosgParticle.dll.a
%{_mingw32_libdir}/libosgManipulator.dll.a
#%%{_mingw32_libdir}/libosgIntrospection.dll.a
%{_mingw32_libdir}/libosgGA.dll.a
%{_mingw32_libdir}/libosgFX.dll.a
%{_mingw32_libdir}/libosgDB.dll.a
%{_mingw32_libdir}/libosgAnimation.dll.a
%{_mingw32_libdir}/libosg.dll.a
%{_mingw32_includedir}/osg*

# OpenThreads
%package -n mingw32-OpenThreads
Summary:        OpenThreads
Group:          Development/Libraries
License:        wxWidgets

Requires:       pkgconfig

%description -n mingw32-OpenThreads
OpenThreads is intended to provide a minimal & complete Object-Oriented (OO)
thread interface for C++ programmers.  It is loosely modeled on the Java
thread API, and the POSIX Threads standards.  The architecture of the 
library is designed around "swappable" thread models which are defined at 
compile-time in a shared object library.

%{_mingw32_description}

%files -n mingw32-OpenThreads
%defattr(-,root,root,-)
%doc %{OSGSRCDIR}/{AUTHORS,LICENSE,NEWS,README}.txt

%{_mingw32_libdir}/pkgconfig/openthreads.pc
%{_mingw32_libdir}/libOpenThreads.dll.a
%{_mingw32_bindir}/libOpenThreads.dll
%{_mingw32_includedir}/OpenThreads

%changelog
* Thu Dec 17 2009 Stefan Riemens <fgfs.stefan@gmail.com> - 2.8.2-2
- Fix unowned directory

* Tue Oct 20 2009 Stefan Riemens <fgfs.stefan@gmail.com> - 2.8.2-1
- Explicitly list every file created in %%files section
- According to the mingw packagin guidelines
- Don't build osg wrapper as they're not necessary
- update BR

* Fri Oct 16 2009 Stefan Riemens <fgfs.stefan@gmail.com> - 2.8.2-0
- Initial mingw release

